Centroid in fTools different form centroid fill
Status: Closed

Priority: Normal

Assignee:

Category: Documentation and Help

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed/implemented

Crashes QGIS or corrupts data:No Copied to github as #: 14347

Description

the centroid, as calculated by fTools, is not in the same location as the centroid shown by the centroid fill. The difference is easily

explained in the case of multipolygons, much less obvious in case of a compact single polygon

History

#1 - 2011-10-21 02:57 AM - Paolo Cavallini

From the ML (thanks cfarmer):

IIRC, the centroid as returned by fTools is based on the GEOS centroid

calculation, whose documentation states:

Based on the usual algorithm for calculating the centroid as a

weighted sum of the centroids of a decomposition of the area into

(possibly overlapping) triangles. The algorithm has been extended to

handle holes and multi-polygons. See

http://www.faqs.org/faqs/graphics/algorithms-faq/ for further details

of the basic approach.

Not sure how the centroid fill centroid is calculated, but obviously

not the same?

#2 - 2011-10-24 06:39 AM - Giovanni Manghi

- Status changed from Open to Feedback

The explanation of the different behavior has benn given in the dev mailing list, closing?

#3 - 2011-12-16 02:10 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#4 - 2011-12-27 12:04 PM - Giovanni Manghi

- Affected QGIS version set to master

- Crashes QGIS or corrupts data set to No

Martin Dobias said:
http://www.faqs.org/faqs/graphics/algorithms-faq/


"The centroid fill uses the same formula. The differences are:

1. centroid fill calculates the centroid for each polygon of

multipolygon separately

2. centroid fill takes into account the polygons clipped to area

visible for rendering

3. centroid fill does not consider holes."

Suggestion: document this difference and close this ticket. Leave feedback.

#5 - 2012-04-16 06:29 AM - Paolo Cavallini

- Target version changed from Version 1.7.4 to Version 1.8.0

#6 - 2012-09-04 11:56 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#7 - 2013-09-09 05:44 AM - Paolo Cavallini

- Status changed from Feedback to Open

- Category changed from Symbology to Documentation and Help

This can be closed when properly documented.

#8 - 2014-06-28 07:41 AM - Jürgen Fischer

- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#9 - 2017-05-01 01:10 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#10 - 2017-05-14 08:49 AM - Harrissou Santanna

- Resolution set to fixed/implemented

- Status changed from Open to Closed

Fixed in https://github.com/qgis/QGIS-Documentation/pull/1880
https://github.com/qgis/QGIS-Documentation/pull/1880

